/* Copyright (C) 2006 P.L. Lucas
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QMainWindow>
#include <QtGui/QMenu>
#include <QtGui/QMenuBar>
#include <QtGui/QStatusBar>
#include <QtGui/QToolBar>
#include <QtGui/QWidget>
#include <QWorkspace>
#include <QMap>
#include "config.h"

class MainWindow:public QMainWindow
{
	public:
	//General actions
	QAction *actionOpen;
	QAction *actionOctave_help;
	QAction *actionTable;
	QAction *actionEditor;
	//Matrix actions
	QAction *actionInverse;
	QAction *actionDeterminant;
	QAction *actionEigenvalues;
	QAction *actionTranspose;
	QAction *actionSubmatrix;
	//Statistics actions
	QAction *actionMean;
	QAction *actionMedian;
	QAction *actionStd;
	QAction *actionCov;
	QAction *actionCorrcoef;
	//Plot actions
	QAction *actionPlot;
	QAction *actionPolar;
	QAction *actionSemilogy;
	QAction *actionSemilogx;
	QAction *actionLogLog;
	QAction *actionAxis;
	QAction *actionTitleLabel;
	QMenu *menu2DPlot;
	QMenu *menuExport;
	QAction *actionToEPS;
	QAction *actionToPDF;
	QAction *actionToPNG;
	//Config actions
	QAction *actionGeneralConfig;
	
	QWorkspace *work_space;
	QMenuBar *menubar;
	QMenu *menuFile;
	QMenu *menuEdit;
	QMenu *menuData;
	QMenu *menuMatrix;
	QMenu *menuStatistics;
	QMenu *menuPlot;
	QMenu *menuConfig;
	QMenu *menuHelp;
	QStatusBar *statusbar;
	QToolBar *toolBar;
	
	MainWindow(QWidget *parent=0);
	void clear_menu();
	void show_menu_base();
	QMap<QString, QAction *> actions;
	QAction *createAction(QString action_name, const char *name, QString icon=QString());
};

#endif
